'ATV QUAD, obroty silnika, prdkociomierz
'pami maksymalnej prdkoci, licznik km

$Crystal=8000000
$regfile = "ATtiny2313a.dat"

Config Portb = Output        'portB - wyjcie
Portb = 255                   'segmenty wyczone
config Portd = &B1110000     'PortD piny 0, 1 - wejscia, reszta - wyjcia
Portd = &B0111111             'waczone wszystkie wywietlacze

Config Timer0 = Timer , Prescale = 256 : Config Timer1 = Timer , Prescale = 64

Enable Interrupts : Enable Timer0 : Enable Timer1
On Timer0 Co4ms             'po przepenieniu licznika T/C0 skocz do etykiety o nazwie Co4ms
On Timer1 Co1s              'po przepenieniu licznika T/C1 skocz do etykiety o nazwie Co1s
On Int0 Sub_int                                             'przerwanie zewnetrzne impulsy drogi
On Int1 Impulsator                                          'przerwanie zewnetrzne sygnay z cewki zaponowej - obroty silnika
Dim Vmax As word, drogatmp As Word, dystans as word
Dim Setne As word
Dim Dzies As word ,sumaimp as byte, sumaobr as byte, obr as byte, ledobr as byte
Dim Wygasz As Bit , Mux As Byte , Migaj As Bit, led as word
dim edystans as eram word at 14, evmax as eram byte at 24
dim kropka as bit, res as byte

ledobr = 0
setne=0
dzies =0
res =0
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
for ledobr = 0 to 8       'bajer, zapala i gasi segmenty: 0,1,2,3,4,5,6,7,8,9
incr setne
incr dzies
waitms 200
next ledobr

for ledobr = 8 to 0 step -1           '9,8,7,6,5,4,3,2,1,0
decr setne
decr dzies
waitms 200
next ledobr
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Config Int1 = Falling
Config Int0 = Falling
Enable Int0
enable int1

led =0
drogatmp=0
sumaimp = 0
obr = 0
kropka = 1
readeeprom dystans , edystans
readeeprom vmax, evmax

'=============================================================================================
Do

while pind.0 = 0     'kiedy trzymasz S1 wywietli przejechany dystans
res =0
do
waitms 100
incr res
if res > 100 then  'po 10 sekundach trzymania skasuje dystans

disable interrupts
set portd.4
set portd.5
set portd.6
dystans = 0
res =0
writeeeprom dystans, edystans
waitms 500
enable interrupts

end if

if dystans < 100 then 'jesli mniej niz 10km
dzies = dystans / 10
setne = dystans mod 10
kropka = 0             'zaswieca kropke
else
setne = dystans / 10
setne = setne mod 10
dzies = dystans / 100
kropka = 1
end if
loop  until pind.0=1
wend

while pind.1 = 0     'kiedy trzymasz S2 wywietla Vmax
res=0
do
waitms 100
incr res
if res > 100 then  'po 10 sekundach trzymania skasuje vmax
disable interrupts
set portd.4
set portd.5
set portd.6
vmax = 0
res =0
waitms 500
writeeeprom vmax, evmax
enable interrupts
end if

dzies = vmax / 10
setne = vmax mod 10
loop  until pind.1=1
wend

if led >99 then  'nie przekroczy 99km/h bo wtedy krzaki na led
led =99
end if

dzies = led /10      'cyfra na 1 pozycji
setne = led mod 10   'druga pozycja

'select case sumaobr      'przelicza ilosc impulsw z cewki na ilo ledw obrotomierza do zawiecenia
'case is < 8 : ledobr = 0
'case  8 to 16 : ledobr = 1
'case 16 to 24 : ledobr = 2
'case 24 to 32 : ledobr = 3
'case 32 to 40 : ledobr = 4
'case 40 to 48 : ledobr = 5
'case 48 to 56 : ledobr = 6
'case is > 80 : ledobr = 7
'end select

ledobr = sumaobr / 11    '9 '10   'przelicza ilosc imp, z cewki na obroty, mniejszy kod !!!

if  drogatmp > 286 then 'staa drogi =35cm * 268 daje 100metrw !!!
drogatmp = 0
incr dystans            '1=100metrw, 10 = 1000metrw czyli 1km

if dystans > 999 then   'licznik nie przekroczy 99km
dystans = 999
end if

writeeeprom dystans, edystans
end if

if led > vmax then      'zapsije maks. predkosc
vmax = led
 if vmax > 99 then
 vmax = 99
 end if
writeeeprom vmax, evmax
end if

Loop

'==================================================================================

Co4ms:                                                   ' obsuga wywietlaczy co 4,096ms
timer0 = 131  'adowanie timera = liczy 4ms

Incr Mux : If Mux = 3 Then Mux = 0 : Portd = &B1111111
Select Case Mux                                         ' obsuga wywietlacza
Case 0:
   Portb = Lookup(setne , Tabela) : Portd.6 = 0
Case 1:
   Portb = Lookup(dzies , Tabela)
    'if dzies = 0 then
    'Portd.6 = 1 'wylacza zbedne zero na pierwszym wyswieltaczu podczas wyswietlania biezacej V
    'else
    portd.5 = 0
    'end if
   if pind.0 = 0 then
    Portb.7 = kropka 'podczas wyswietlania dystansu kiedy <10km zaswieci kropke czyli maks.9,9km
   else
   portb.7 = 1
   end if
Case 2:
Portb = Lookup(ledobr , Tabela2) : Portd.4 = 0
End Select

Return         'koniec obsugi przerwania od T/C0


'-------------------------------------------------------------------------------------------------------------
Co1s:                'wyskoczy co 0,5 sekundy
timer1 = 3036    'zaaduj do Timera1, eby zliczy 62500 (=65535-3036)impulsw =0,5s

sumaobr = obr       'obroty dwa razy na sekunde wyswietli
obr = 0

Toggle Migaj       'obliczenia co sekunde

if migaj = 1 then
led = sumaimp      'suma impulsw z czujnika VSS
drogatmp = drogatmp + sumaimp 'sumuje przejechany dystans
sumaimp = 0
led = led*126       'staa drogi 35cm/impuls, razy 3,6 -- m/s -> km/h ==>1,26
led = led/100        'predkosc raz na sekunde
end if

Return             'koniec procedury obsugi przerwania od T/C1
'---------------------------------------------------------------------------------------------------

Sub_int:            'obsuga czujnika VSS
Incr Sumaimp
Return

Impulsator:      'zlicza sygnay z cewki zaponowej
incr obr
Return

Tabela:                     ' dane do wywietlania kolejnych cyfr od 0 do 9
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144

Tabela2:                      'zapala segmenty a,b,c,d,e,f,g,dp  steruje ledami obrotomierza
Data   255, 254, 252, 248,  240, 224, 192,  128, 0